// not UNIX

#include "stdafx.h"
#include "Strawberry.h"

#include "MainFrm.h"
#include "ChildFrm.h"

#include "StrawberryDoc.h"
#include "StrawberryView.h"
#include "CntrItem.h"

#include "New_Class.h"

#ifdef UNICODE
wchar_t *make_long_func(BYTE *str)
{
  DWORD k;
  ChangeCharset(ch_set, 64, str, (BYTE *)string3, &k, default_char);
  return (wchar_t *)string3;
}
char *make_utf8_func(CString str)
{
  DWORD k;
  ChangeCharset(64, 0, (BYTE *)(LPCTSTR)str, (BYTE *)string2, &k, default_char);
  return string2;
}
char *make_short_func(CString str)
{
  DWORD k;
  ChangeCharset(64, ch_set, (BYTE *)(LPCTSTR)str, (BYTE *)string2, &k, default_char);
  return string2;
}
#endif

BOOL SelectFile(CString& Buffer, HWND Father, LPTSTR Title, LPTSTR Filter, BOOL bMust)
{
  OPENFILENAME of;

  memset(&of, '\0', sizeof(OPENFILENAME));
  of.lStructSize  = sizeof(OPENFILENAME);
  of.hwndOwner    = Father;       // NULL
  of.lpstrFilter  = Filter;
  of.lpstrCustomFilter = NULL;
  of.nFilterIndex = 1;
  of.lpstrFile    = Buffer.GetBuffer(_MAX_PATH);
  of.nMaxFile     = 256;
  of.lpstrInitialDir = NULL;
  of.lpstrTitle   = Title;
  if (bMust)
    of.Flags      = OFN_HIDEREADONLY|OFN_FILEMUSTEXIST;
  else
    of.Flags      = OFN_HIDEREADONLY;
  of.lpstrDefExt  = NULL;

  BOOL bRet=GetOpenFileName(&of);
  Buffer.ReleaseBuffer();
  return bRet;
}
void MitiRedraw(void)
{
    if (pStack)
      pStack->InvalidateRect(NULL, TRUE);
    if (pVariables)
      pVariables->InvalidateRect(NULL, TRUE);
    if (pProofTree)                   /* TRACE */
    {
      open_br=0;
      if (pProofTree->short_print+pProofTree->tight+pProofTree->underline+pProofTree->highlight
            +pProofTree->prefix+pProofTree->show_vars+pProofTree->stack_numbers==0)
        my_sprintf(string3,_T("Proof Tree - step %u."), 0x10000*lSteps_br+Steps_br-Correction);
      else
        my_sprintf(string3,_T("Proof Tree - step %u, (%s%s%s%s%s%s%s )."), 0x10000*lSteps_br+Steps_br-Correction,
               pProofTree->short_print?_T(" Short"):_T(""),
               pProofTree->tight?_T(" Tight"):_T(""),
               pProofTree->underline?_T(" Underline"):_T(""),
               pProofTree->highlight?_T(" Highlight"):_T(""),
               pProofTree->prefix?_T(" Prefix"):_T(""),
               pProofTree->show_vars?_T(" Vars"):_T(""),
               pProofTree->stack_numbers?_T(" Numbers"):_T("") );
      pProofTree->SetWindowText(string3);
      selected_line=M1;
      pProofTree->InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
    }
}

void ShowInformation(int Type)
{
  CString WinNane;
  switch(Type)
  {
#if TR
   case 1:
    WinNane="Closed Terms";
    break;
   case 2:
    WinNane="Open Terms";
    break;
   case 3:
    WinNane="Tree";
    break;
   case 4:
    WinNane="Blocks (Good)";
    break;
#endif
   case 5:
    WinNane="System List";
    break;
   case 6:
    if (pStack!=NULL)
    {
      pStack->BringWindowToTop();
      return;
    }
    WinNane="Stack";
    break;
   case 7:
    if (pVariables!=NULL)
    {
      pVariables->BringWindowToTop();
      return;
    }
    WinNane="Variables";
    break;
   case 8:
    WinNane="Operators";
    break;
   case 11:
    WinNane="Objects";
    break;
   case 17:
    WinNane="Functions and predicates with typed arguments";
    break;
#if TR
   case 9:
    WinNane="Constants";
    break;
   case 10:
    WinNane="Key Map";
    break;
   case 12:
    WinNane="Blocks";
    break;
   case 18:
    WinNane="Link";
    break;
   case 13:
    WinNane="Ekler";
    break;
   case 14:
    WinNane="D_Field";
    break;
   case 15:
    WinNane="Pointers";
    break;
   case 16:
    WinNane="F_Field";
    break;
#endif
  }
  CwInformation* pInformation=new CwInformation(Type);
  CRect rect(Screen.cx/2, 8, Screen.cx-8, Screen.cy-38);
  pInformation->Create( AfxRegisterWndClass( 0, theApp.LoadStandardCursor(IDC_ARROW),
    CreateSolidBrush(GetSysColor(COLOR_WINDOW)), theApp.LoadIcon(IDI_ICON) ),
    WinNane, WS_OVERLAPPEDWINDOW | WS_CAPTION | WS_SYSMENU
    | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_VSCROLL | WS_HSCROLL,
    rect, 0, NULL);
  pInformation->ShowWindow(SW_SHOWNORMAL);
  pInformation->UpdateWindow();
  if (Type==6)
    pStack=pInformation;
  else if (Type==7)
    pVariables=pInformation;
}
// Source code for passwords coding and MakeExe - it's missing
//***
